#!/bin/sh

set -e

# Interpolate PAYLOAD_TEMPLATE using the provided ENV variables
PAYLOAD=$(python3 -c '
from os import environ
from string import Template
print(Template(environ["PAYLOAD_TEMPLATE"]).substitute(environ))
')

endpoint_arg=
if [ -n "${CB_LC_OVERRIDE_AWS_ENDPOINT_LAMBDA}" ]; then
    endpoint_arg="--endpoint-url https://${CB_LC_OVERRIDE_AWS_ENDPOINT_LAMBDA}"
    echo "Using Lambda AWS API endpoint override of ${CB_LC_OVERRIDE_AWS_ENDPOINT_LAMBDA}"
fi

# Invoke the lambda asynchronously
aws                                                \
    ${endpoint_arg}                                \
    lambda invoke --invocation-type Event          \
                  --function-name "${LAMBDA_NAME}" \
                  --payload "${PAYLOAD}"           \
                  /tmp/response.json > /tmp/response.json

# Check that the invocation was scheduled successfully
grep '"StatusCode": 202' /tmp/response.json
